!!ARBfp1.0
#
# simple fur shader
# on entry:
#     fragment.texcoord [0] - texture coordinates
#	  fragment.texcoord [1] - l in tangent space
#     fragment.texcoord [2] - h in tangent space
#     fragment.texcoord [3] - t in tangent space
#
#	  texture [0] - current fur layer texture
#     texture [1] - current fur tangent map
#

ATTRIB	l           = fragment.texcoord [1];
ATTRIB	h           = fragment.texcoord [2];
ATTRIB	t           = fragment.texcoord [3];
PARAM	one         = 1.0;
PARAM	diffusePow  = 1.0;
PARAM	specularPow = 30.0;
PARAM	ka          = 0.2;
PARAM	specColor   = { 1, 1, 1, 1 };
PARAM	n           = { 0, 0, 1 };

TEMP	ln, hn, color, h2, l2, n2, t2, temp, diffuse, dist, atten, ctex, dots, color2, tt;

												# normalize l
DP3		dist.w, l, l;
RSQ		l2.w, dist.w;
MUL		l2.xyz, l, l2.w;

												# normalize h
DP3		h2.w, h, h;
RSQ		h2.w, h2.w;
MUL		h2.xyz, h, h2.w;

												# adjust and normalize t
TEX		tt, fragment.texcoord [0], texture [1], 2D;
ADD		tt, tt, -n;
ADD		tt, tt, t;
DP3		t2.w, tt, tt;
RSQ		t2.w, t2.w;
MUL		t2.xyz, tt, t2.w;

												# get value from fur texture
TEX		ctex, fragment.texcoord [0], texture [0], 2D;
MUL		ctex, ctex, fragment.color;				# modulate with current color (and transparency)

												# compute ((t,l), (t,h))
DP3		dots.x, l2, t2;
DP3		dots.y, h2, t2;
MUL		dots, dots, dots;						# square them
ADD		dots, 1, -dots;

								# compute powers
POW		dots.x, dots.x, diffusePow.x;
POW		dots.y, dots.y, specularPow.x;


												# now combine diffuse and specular lighting
MUL		color.rgb,  specColor, dots.y;			# specular component
MUL		color,      color,     ctex.a;
MUL		color2.rgb, ctex,      dots.x;			# diffuse component
ADD_SAT	result.color, color, color2;
MOV		result.color.a, ctex.a;
END
